<?php
  Namespace Core\library;  
  
  Class Geo{
      static $radius = 20;
      static $unit   = "km"; //mi -miles km - kilometers
      static $blockedCountries = ['BJ'];
      
       
      static $countryCodes = [
         "AF" => "Afghanistan",
         "AX" => "Åland Islands",
         "AL" => "Albania",
         "DZ" => "Algeria",
         "AS" => "American Samoa",
         "AD" => "Andorra",
         "AO" => "Angola",
         "AI" => "Anguilla",
         "AQ" => "Antarctica",
         "AG" => "Antigua and Barbuda",
         "AR" => "Argentina",
         "AM" => "Armenia",
         "AW" => "Aruba",
         "AU" => "Australia",
         "AT" => "Austria",
         "AZ" => "Azerbaijan",
         "BS" => "Bahamas",
         "BH" => "Bahrain",
         "BD" => "Bangladesh",
         "BB" => "Barbados",
         "BY" => "Belarus",
         "BE" => "Belgium",
         "BZ" => "Belize",
         "BJ" => "Benin",
         "BM" => "Bermuda",
         "BT" => "Bhutan",
         "BO" => "Bolivia, Plurinational State of",
         "BQ" => "Bonaire, Sint Eustatius and Saba",
         "BA" => "Bosnia and Herzegovina",
         "BW" => "Botswana",
         "BV" => "Bouvet Island",
         "BR" => "Brazil",
         "IO" => "British Indian Ocean Territory",
         "BN" => "Brunei Darussalam",
         "BG" => "Bulgaria",
         "BF" => "Burkina Faso",
         "BI" => "Burundi",
         "KH" => "Cambodia",
         "CM" => "Cameroon",
         "CA" => "Canada",
         "CV" => "Cape Verde",
         "KY" => "Cayman Islands",
         "CF" => "Central African Republic",
         "TD" => "Chad",
         "CL" => "Chile",
         "CN" => "China",
         "CX" => "Christmas Island",
         "CC" => "Cocos (Keeling) Islands",
         "CO" => "Colombia",
         "KM" => "Comoros",
         "CG" => "Congo",
         "CD" => "Congo, the Democratic Republic of the",
         "CK" => "Cook Islands",
         "CR" => "Costa Rica",
         "CI" => "Côte d'Ivoire",
         "HR" => "Croatia",
         "CU" => "Cuba",
         "CW" => "Curaçao",
         "CY" => "Cyprus",
         "CZ" => "Czech Republic",
         "DK" => "Denmark",
         "DJ" => "Djibouti",
         "DM" => "Dominica",
         "DO" => "Dominican Republic",
         "EC" => "Ecuador",
         "EG" => "Egypt",
         "SV" => "El Salvador",
         "GQ" => "Equatorial Guinea",
         "ER" => "Eritrea",
         "EE" => "Estonia",
         "ET" => "Ethiopia",
         "FK" => "Falkland Islands (Malvinas)",
         "FO" => "Faroe Islands",
         "FJ" => "Fiji",
         "FI" => "Finland",
         "FR" => "France",
         "GF" => "French Guiana",
         "PF" => "French Polynesia",
         "TF" => "French Southern Territories",
         "GA" => "Gabon",
         "GM" => "Gambia",
         "GE" => "Georgia",
         "DE" => "Germany",
         "GH" => "Ghana",
         "GI" => "Gibraltar",
         "GR" => "Greece",
         "GL" => "Greenland",
         "GD" => "Grenada",
         "GP" => "Guadeloupe",
         "GU" => "Guam",
         "GT" => "Guatemala",
         "GG" => "Guernsey",
         "GN" => "Guinea",
         "GW" => "Guinea-Bissau",
         "GY" => "Guyana",
         "HT" => "Haiti",
         "HM" => "Heard Island and McDonald Islands",
         "VA" => "Holy See (Vatican City State)",
         "HN" => "Honduras",
         "HK" => "Hong Kong",
         "HU" => "Hungary",
         "IS" => "Iceland",
         "IN" => "India",
         "ID" => "Indonesia",
         "IR" => "Iran, Islamic Republic of",
         "IQ" => "Iraq",
         "IE" => "Ireland",
         "IM" => "Isle of Man",
         "IL" => "Israel",
         "IT" => "Italy",
         "JM" => "Jamaica",
         "JP" => "Japan",
         "JE" => "Jersey",
         "JO" => "Jordan",
         "KZ" => "Kazakhstan",
         "KE" => "Kenya",
         "KI" => "Kiribati",
         "KP" => "Korea, Democratic People's Republic of",
         "KR" => "Korea, Republic of",
         "KW" => "Kuwait",
         "KG" => "Kyrgyzstan",
         "LA" => "Lao People's Democratic Republic",
         "LV" => "Latvia",
         "LB" => "Lebanon",
         "LS" => "Lesotho",
         "LR" => "Liberia",
         "LY" => "Libya",
         "LI" => "Liechtenstein",
         "LT" => "Lithuania",
         "LU" => "Luxembourg",
         "MO" => "Macao",
         "MK" => "Macedonia, the Former Yugoslav Republic of",
         "MG" => "Madagascar",
         "MW" => "Malawi",
         "MY" => "Malaysia",
         "MV" => "Maldives",
         "ML" => "Mali",
         "MT" => "Malta",
         "MH" => "Marshall Islands",
         "MQ" => "Martinique",
         "MR" => "Mauritania",
         "MU" => "Mauritius",
         "YT" => "Mayotte",
         "MX" => "Mexico",
         "FM" => "Micronesia, Federated States of",
         "MD" => "Moldova, Republic of",
         "MC" => "Monaco",
         "MN" => "Mongolia",
         "ME" => "Montenegro",
         "MS" => "Montserrat",
         "MA" => "Morocco",
         "MZ" => "Mozambique",
         "MM" => "Myanmar",
         "NA" => "Namibia",
         "NR" => "Nauru",
         "NP" => "Nepal",
         "NL" => "Netherlands",
         "NC" => "New Caledonia",
         "NZ" => "New Zealand",
         "NI" => "Nicaragua",
         "NE" => "Niger",
         "NG" => "Nigeria",
         "NU" => "Niue",
         "NF" => "Norfolk Island",
         "MP" => "Northern Mariana Islands",
         "NO" => "Norway",
         "OM" => "Oman",
         "PK" => "Pakistan",
         "PW" => "Palau",
         "PS" => "Palestine, State of",
         "PA" => "Panama",
         "PG" => "Papua New Guinea",
         "PY" => "Paraguay",
         "PE" => "Peru",
         "PH" => "Philippines",
         "PN" => "Pitcairn",
         "PL" => "Poland",
         "PT" => "Portugal",
         "PR" => "Puerto Rico",
         "QA" => "Qatar",
         "RE" => "Réunion",
         "RO" => "Romania",
         "RU" => "Russian Federation",
         "RW" => "Rwanda",
         "BL" => "Saint Barthélemy",
         "SH" => "Saint Helena, Ascension and Tristan da Cunha",
         "KN" => "Saint Kitts and Nevis",
         "LC" => "Saint Lucia",
         "MF" => "Saint Martin (French part)",
         "PM" => "Saint Pierre and Miquelon",
         "VC" => "Saint Vincent and the Grenadines",
         "WS" => "Samoa",
         "SM" => "San Marino",
         "ST" => "Sao Tome and Principe",
         "SA" => "Saudi Arabia",
         "SN" => "Senegal",
         "RS" => "Serbia",
         "SC" => "Seychelles",
         "SL" => "Sierra Leone",
         "SG" => "Singapore",
         "SX" => "Sint Maarten (Dutch part)",
         "SK" => "Slovakia",
         "SI" => "Slovenia",
         "SB" => "Solomon Islands",
         "SO" => "Somalia",
         "ZA" => "South Africa",
         "GS" => "South Georgia and the South Sandwich Islands",
         "SS" => "South Sudan",
         "ES" => "Spain",
         "LK" => "Sri Lanka",
         "SD" => "Sudan",
         "SR" => "Suriname",
         "SJ" => "Svalbard and Jan Mayen",
         "SZ" => "Swaziland",
         "SE" => "Sweden",
         "CH" => "Switzerland",
         "SY" => "Syrian Arab Republic",
         "TW" => "Taiwan, Province of China",
         "TJ" => "Tajikistan",
         "TZ" => "Tanzania, United Republic of",
         "TH" => "Thailand",
         "TL" => "Timor-Leste",
         "TG" => "Togo",
         "TK" => "Tokelau",
         "TO" => "Tonga",
         "TT" => "Trinidad and Tobago",
         "TN" => "Tunisia",
         "TR" => "Turkey",
         "TM" => "Turkmenistan",
         "TC" => "Turks and Caicos Islands",
         "TV" => "Tuvalu",
         "UG" => "Uganda",
         "UA" => "Ukraine",
         "AE" => "United Arab Emirates",
         "GB" => "United Kingdom",
         "US" => "United States",
         "UM" => "United States Minor Outlying Islands",
         "UY" => "Uruguay",
         "UZ" => "Uzbekistan",
         "VU" => "Vanuatu",
         "VE" => "Venezuela, Bolivarian Republic of",
         "VN" => "Viet Nam",
         "VG" => "Virgin Islands, British",
         "VI" => "Virgin Islands, U.S.",
         "WF" => "Wallis and Futuna",
         "EH" => "Western Sahara",
         "YE" => "Yemen",
         "ZM" => "Zambia",
         "ZW" => "Zimbabwe"
      ] ;
      
      static $cities = array (
          0 => array(   'city' => 'Acton Vale', 'lat' => 45.6470539, 'long' => -72.5650634),
          1 => array(   'city' => 'Alma', 'lat' => 48.550461, 'long' => -71.65277),
          2 => array(   'city' => 'Anjou', 'lat' => 45.6159585, 'long' => -73.5693509),
          3 => array(   'city' => 'Baie-Comeau', 'lat' => 49.2212971, 'long' => -68.1503944),
          4 => array(   'city' => 'Baie-d\'urfe', 'lat' => 45.416456, 'long' => -73.9160797),
          5 => array(   'city' => 'Beaconsfiel', 'lat' => 45.430931, 'long' => -73.868283),
          6 => array(   'city' => 'Beauport', 'lat' => 46.861556, 'long' => -71.188677),
          7 => array(   'city' => 'Becancour', 'lat' => 46.3506215, 'long' => -72.4350552),
          8 => array(   'city' => 'Beloeil', 'lat' => 45.5679246, 'long' => -73.203947),
          9 => array(   'city' => 'Berthierville', 'lat' => 46.083474, 'long' => -73.1847588),
          10 => array(   'city' => 'Blainville', 'lat' => 45.6688961, 'long' => -73.8728751),
          11 => array(   'city' => 'Bois-des-Filion', 'lat' => 45.6667418, 'long' => -73.7567021),
          12 => array(   'city' => 'Boisbriand', 'lat' => 45.6126338, 'long' => -73.8383733),
          13 => array(   'city' => 'Boucherville', 'lat' => 45.5913698, 'long' => -73.4364097),
          14 => array(   'city' => 'Bromont', 'lat' => 45.28524789999999, 'long' => -72.6872419),
          15 => array(   'city' => 'Brossard', 'lat' => 45.4514357, 'long' => -73.4619103),
          16 => array(   'city' => 'Burlington', 'lat' => 43.32552, 'long' => -79.799032),
          17 => array(   'city' => 'Campbellton', 'lat' => 48.007399, 'long' => -66.672206),
          18 => array(   'city' => 'Candiac', 'lat' => 45.3839341, 'long' => -73.517445),
          19 => array(   'city' => 'Cap-de-la-Madeleine', 'lat' => 46.3622521, 'long' => -72.5067098),
          20 => array(   'city' => 'Carignan', 'lat' => 45.45932, 'long' => -73.3068139),
          21 => array(   'city' => 'Chambly', 'lat' => 45.4391627, 'long' => -73.2902464),
          22 => array(   'city' => 'Charlemagne', 'lat' => 45.7249153, 'long' => -73.4913241),
          23 => array(   'city' => 'Charlesbourg', 'lat' => 46.8997293, 'long' => -71.2864748),
          24 => array(   'city' => 'Charny', 'lat' => 46.7146359, 'long' => -71.2604518),
          25 => array(   'city' => 'Chateauguay', 'lat' => 45.360159, 'long' => -73.749403),
          26 => array(   'city' => 'Chibougamau', 'lat' => 49.9132295, 'long' => -74.3691986),
          27 => array(   'city' => 'Chicoutimi', 'lat' => 48.3516735, 'long' => -71.1385136),
          28 => array(   'city' => 'Contrecoeur', 'lat' => 45.8654102, 'long' => -73.2412826),
          29 => array(   'city' => 'Cornwall', 'lat' => 45.01809, 'long' => -74.72815),
          30 => array(   'city' => 'Cote-Saint-Luc', 'lat' => 45.4680498, 'long' => -73.6729464),
          31 => array(   'city' => 'Delson', 'lat' => 45.37161589999999, 'long' => -73.5426529),
          32 => array(   'city' => 'Deux-Montagnes', 'lat' => 45.5418051, 'long' => -73.89321079999999),
          33 => array(   'city' => 'Dollard-des-Ormeaux', 'lat' => 45.4895636, 'long' => -73.8205567),
          34 => array(   'city' => 'Dorval', 'lat' => 45.4503213, 'long' => -73.7500486),
          35 => array(   'city' => 'Drummondville', 'lat' => 45.8802909, 'long' => -72.4842824),
          36 => array(   'city' => 'Durham-Sud', 'lat' => 45.66035, 'long' => -72.340038),
          37 => array(   'city' => 'Edmundston', 'lat' => 47.3690127, 'long' => -68.3266741),
          38 => array(   'city' => 'Fermont', 'lat' => 52.7953958, 'long' => -67.0842673),
          39 => array(   'city' => 'Gatineau', 'lat' => 45.4765446, 'long' => -75.7012723),
          40 => array(   'city' => 'Granby', 'lat' => 45.403229, 'long' => -72.734066),
          41 => array(   'city' => 'Greenfield-Park', 'lat' => 45.485358, 'long' => -73.478654),
          42 => array(   'city' => 'Hawkesbury', 'lat' => 45.6071264, 'long' => -74.604189),
          43 => array(   'city' => 'Joliette', 'lat' => 46.014012, 'long' => -73.4177961),
          44 => array(   'city' => 'Jonquiere', 'lat' => 48.423604, 'long' => -71.2395463),
          45 => array(   'city' => 'Kingsey-falls', 'lat' => 45.8606766, 'long' => -72.0712829),
          46 => array(   'city' => 'Kirkland', 'lat' => 45.456042, 'long' => -73.862334),
          47 => array(   'city' => 'L\'Ancienne-Lorette', 'lat' => 46.8063093, 'long' => -71.3570091),
          48 => array(   'city' => 'L\'Assomption', 'lat' => 45.8519896, 'long' => -73.4123978),
          49 => array(   'city' => 'L\'Epiphanie', 'lat' => 45.846967, 'long' => -73.4924769),
          50 => array(   'city' => 'L-assomption', 'lat' => 45.8519896, 'long' => -73.4123978),
          51 => array(   'city' => 'La-Prairie', 'lat' => 40.7654174, 'long' => -73.975942),
          52 => array(   'city' => 'Lac-Simon', 'lat' => 45.899929, 'long' => -75.0979221),
          53 => array(   'city' => 'Lachine', 'lat' => 45.441347, 'long' => -73.6885847),
          54 => array(   'city' => 'Lanoraie', 'lat' => 45.9587019, 'long' => -73.2196697),
          55 => array(   'city' => 'LaSalle', 'lat' => 40.0387561, 'long' => -75.1566322),
          56 => array(   'city' => 'Laval', 'lat' => 45.6066487, 'long' => -73.712409),
          57 => array(   'city' => 'Lavaltrie', 'lat' => 45.8781705, 'long' => -73.2848829),
          58 => array(   'city' => 'LeMoyne', 'lat' => 43.0497018, 'long' => -76.0855042),
          59 => array(   'city' => 'lery', 'lat' => 45.34441289999999, 'long' => -73.8059179),
          60 => array(   'city' => 'Les Coteaux', 'lat' => 45.2593027, 'long' => -74.206729),
          61 => array(   'city' => 'Levis', 'lat' => 36.6444928, 'long' => -93.2661031),
          62 => array(   'city' => 'Longue-Rive', 'lat' => 48.550157, 'long' => -69.248703),
          63 => array(   'city' => 'Longueuil', 'lat' => 45.5369442, 'long' => -73.5107131),
          64 => array(   'city' => 'Lorraine', 'lat' => 45.670359, 'long' => -73.788845),
          65 => array(   'city' => 'Magog', 'lat' => 45.2664863, 'long' => -72.1479889),
          66 => array(   'city' => 'Marieville', 'lat' => 45.4326294, 'long' => -73.1602036),
          67 => array(   'city' => 'Mascouche', 'lat' => 45.7773374, 'long' => -73.6323926),
          68 => array(   'city' => 'Massena', 'lat' => 44.9281049, 'long' => -74.891865),
          69 => array(   'city' => 'Matane', 'lat' => 48.8445157, 'long' => -67.5305758),
          70 => array(   'city' => 'McMasterville', 'lat' => 45.5488739, 'long' => -73.2233935),
          71 => array(   'city' => 'Mercier', 'lat' => 45.311465, 'long' => -73.743229),
          72 => array(   'city' => 'Mirabel', 'lat' => 45.6518959, 'long' => -74.0901696),
          73 => array(   'city' => 'Mont-Laurier', 'lat' => 46.5504129, 'long' => -75.4960308),
          74 => array(   'city' => 'Mont-Royal', 'lat' => 45.5071024, 'long' => -73.5874071),
          75 => array(   'city' => 'Mont-Saint-Hilaire', 'lat' => 45.5640416, 'long' => -73.1790126),
          76 => array(   'city' => 'Mont-Tremblant', 'lat' => 46.1184616, 'long' => -74.5961852),
          77 => array(   'city' => 'Montmagny', 'lat' => 46.9801031, 'long' => -70.5565719),
          78 => array(   'city' => 'Montpellier', 'lat' => 45.925124, 'long' => -75.253489),
          79 => array(   'city' => 'Montreal', 'lat' => 45.5016889, 'long' => -73.567256),
          80 => array(   'city' => 'Montreal-Est', 'lat' => 45.6320003, 'long' => -73.5066981),
          81 => array(   'city' => 'Montreal-Nord', 'lat' => 45.6071981, 'long' => -73.6314736),
          82 => array(   'city' => 'Montreal-Ouest', 'lat' => 45.4524845, 'long' => -73.6475131),
          83 => array(   'city' => 'Napierville', 'lat' => 45.1864857, 'long' => -73.4051146),
          84 => array(   'city' => 'Newport', 'lat' => 45.410659, 'long' => -71.425838),
          85 => array(   'city' => 'Nicolet', 'lat' => 46.227406, 'long' => -72.619174),
          86 => array(   'city' => 'Oka', 'lat' => 45.4651444, 'long' => -74.0798679),
          87 => array(   'city' => 'Ottawa', 'lat' => 45.4215296, 'long' => -75.6971931),
          88 => array(   'city' => 'Otterburn-park', 'lat' => 45.5448938, 'long' => -73.2010448),
          89 => array(   'city' => 'Outremont', 'lat' => 45.5142856, 'long' => -73.60901139),
          90 => array(   'city' => 'Pierrefonds', 'lat' => 45.4688309, 'long' => -73.8755827),
          91 => array(   'city' => 'Pierreville', 'lat' => 46.0695388, 'long' => -72.8093624),
          92 => array(   'city' => 'Plattsburgh', 'lat' => 44.6994873, 'long' => -73.4529124),
          93 => array(   'city' => 'Plessisville', 'lat' => 46.2194458, 'long' => -71.7713791),
          94 => array(   'city' => 'Pointe-aux-trembles', 'lat' => 45.6416665, 'long' => -73.5004013),
          95 => array(   'city' => 'Pointe-Calumet', 'lat' => 45.4985069, 'long' => -73.969932),
          96 => array(   'city' => 'Pointe-Claire', 'lat' => 45.4719655, 'long' => -73.7990191),
          97 => array(   'city' => 'Pont-Rouge', 'lat' => 46.7562377, 'long' => -71.6984316),
          98 => array(   'city' => 'Portneuf', 'lat' => 42.7949145, 'long' => -112.3635862),
          99 => array(   'city' => 'Princeville', 'lat' => 46.166991, 'long' => -71.875577),
          100 => array(   'city' => 'Quebec', 'lat' => 46.8138783, 'long' => -71.2079809),
          101 => array(   'city' => 'Rawdon', 'lat' => 46.065488, 'long' => -73.7340588),
          102 => array(   'city' => 'Repentigny', 'lat' => 45.7532854, 'long' => -73.4400814),
          103 => array(   'city' => 'Richelieu', 'lat' => 45.440422, 'long' => -73.245988),
          104 => array(   'city' => 'Rigaud', 'lat' => 45.4830738, 'long' => -74.282199),
          105 => array(   'city' => 'Rimouski', 'lat' => 48.4389803, 'long' => -68.5349704),
          106 => array(   'city' => 'Riviere-du-Loup', 'lat' => 47.835957, 'long' => -69.5359854),
          107 => array(   'city' => 'Rosemere', 'lat' => 45.638974, 'long' => -73.785008),
          108 => array(   'city' => 'Rouyn-Noranda', 'lat' => 48.2342362, 'long' => -79.0187836),
          109 => array(   'city' => 'Roxboro', 'lat' => 45.505265, 'long' => -73.803304),
          110 => array(   'city' => 'Saguenay', 'lat' => 48.4280529, 'long' => -71.0684923),
          111 => array(   'city' => 'Saint-Augustin', 'lat' => 51.232769, 'long' => -58.651544),
          112 => array(   'city' => 'Saint-Basile', 'lat' => 46.7562692, 'long' => -71.8247768),
          113 => array(   'city' => 'Saint-basile-le-grand', 'lat' => 45.5218886, 'long' => -73.2854066),
          114 => array(   'city' => 'Saint-Blaise-sur-Richelieu', 'lat' => 45.2161953, 'long' => -73.30786),
          115 => array(   'city' => 'Saint-Constant', 'lat' => 45.379181, 'long' => -73.56449130000001),
          116 => array(   'city' => 'Saint-Cyrille-de-Wendover', 'lat' => 45.9328471, 'long' => -72.424601),
          117 => array(   'city' => 'Saint-Esprit', 'lat' => 45.91038940000001, 'long' => -73.6758303),
          118 => array(   'city' => 'Saint-Eustache', 'lat' => 45.5585489, 'long' => -73.89607520000001),
          119 => array(   'city' => 'Saint-Gabriel-de-Valcartier', 'lat' => 46.937554, 'long' => -71.470228),
          120 => array(   'city' => 'Saint-Georges', 'lat' => 46.122918, 'long' => -70.670352),
          121 => array(   'city' => 'Saint-germain-de-grantham', 'lat' => 45.8120257, 'long' => -72.5760702),
          122 => array(   'city' => 'Saint-Hippolyte', 'lat' => 45.9309787, 'long' => -74.0247596),
          123 => array(   'city' => 'Saint-Hubert', 'lat' => 40.0308244, 'long' => -75.034534),
          124 => array(   'city' => 'Saint-Hyacinthe', 'lat' => 45.6306875, 'long' => -72.956339),
          125 => array(   'city' => 'Saint-Jean-Baptiste', 'lat' => 40.7721401, 'long' => -73.9599338),
          126 => array(   'city' => 'Saint-Jean-sur-Richelieu', 'lat' => 45.305771, 'long' => -73.2544903),
          127 => array(   'city' => 'Saint-Jerome', 'lat' => 45.775357, 'long' => -74.004948),
          128 => array(   'city' => 'Saint-joseph-du-Lac', 'lat' => 45.5339469, 'long' => -74.0279695),
          129 => array(   'city' => 'Saint-Lambert', 'lat' => 45.4920344, 'long' => -73.5041752),
          130 => array(   'city' => 'Saint-Laurent', 'lat' => 45.498564, 'long' => -73.749757),
          131 => array(   'city' => 'Saint-Lazare', 'lat' => 45.399813, 'long' => -74.137765),
          132 => array(   'city' => 'Saint-Leonard', 'lat' => 45.5874727, 'long' => -73.5970099),
          133 => array(   'city' => 'Saint-Lin-Laurentides', 'lat' => 45.8524432, 'long' => -73.7572393),
          134 => array(   'city' => 'Saint-Mathias-sur-Richelieu', 'lat' => 45.4752088, 'long' => -73.23264209999999),
          135 => array(   'city' => 'Saint-Sauveur', 'lat' => 45.8940717, 'long' => -74.157934),
          136 => array(   'city' => 'Saint-sulpice', 'lat' => 45.825316, 'long' => -73.359313),
          137 => array(   'city' => 'Saint-Zotique', 'lat' => 45.2428605, 'long' => -74.2459569),
          138 => array(   'city' => 'Sainte-Agathe-des-Monts', 'lat' => 46.0485628, 'long' => -74.281603),
          139 => array(   'city' => 'Sainte-Angele-de-Monnoir', 'lat' => 45.390371, 'long' => -73.10836),
          140 => array(   'city' => 'Sainte-Anne-des-Lacs', 'lat' => 45.8704803, 'long' => -74.1171529),
          141 => array(   'city' => 'Sainte-anne-des-plaines', 'lat' => 45.7596011, 'long' => -73.81512),
          142 => array(   'city' => 'Sainte-catherine', 'lat' => 45.39582, 'long' => -73.5657429),
          143 => array(   'city' => 'Sainte-Foy', 'lat' => 46.7829958, 'long' => -71.2860696),
          144 => array(   'city' => 'Sainte-Julie', 'lat' => 45.5924997, 'long' => -73.3426988),
          145 => array(   'city' => 'Sainte-Marguerite', 'lat' => 46.510396, 'long' => -70.937758),
          146 => array(   'city' => 'Sainte-Marie', 'lat' => 46.4390284, 'long' => -71.0213182),
          147 => array(   'city' => 'Sainte-Marthe-sur-le-Lac', 'lat' => 45.5290874, 'long' => -73.9325655),
          148 => array(   'city' => 'Sainte-Sophie', 'lat' => 45.8206187, 'long' => -73.9300943),
          149 => array(   'city' => 'Sainte-Therese', 'lat' => 45.6397183, 'long' => -73.8439099),
          150 => array(   'city' => 'Salaberry-de-Valleyfield', 'lat' => 45.2500909, 'long' => -74.1330862),
          151 => array(   'city' => 'Sept-Iles', 'lat' => 50.2132968, 'long' => -66.375792),
          152 => array(   'city' => 'Shawinigan', 'lat' => 46.5618559, 'long' => -72.7435254),
          153 => array(   'city' => 'Sherbrooke', 'lat' => 45.4041718, 'long' => -71.8929107),
          154 => array(   'city' => 'Sorel-Tracy', 'lat' => 46.042825, 'long' => -73.112302),
          155 => array(   'city' => 'Terrebonne', 'lat' => 45.6929818, 'long' => -73.63311019999999),
          156 => array(   'city' => 'Thetford-Mines', 'lat' => 46.1028329, 'long' => -71.3055522),
          157 => array(   'city' => 'Trois-Rivieres', 'lat' => 46.342982, 'long' => -72.5420716),
          158 => array(   'city' => 'Trois-Rivieres-Ouest', 'lat' => 46.3250649, 'long' => -72.5710348),
          159 => array(   'city' => 'Val-d\'Or', 'lat' => 48.0987106, 'long' => -77.7967676),
          160 => array(   'city' => 'Varennes', 'lat' => 45.681034, 'long' => -73.437497),
          161 => array(   'city' => 'Vaudreuil-Dorion', 'lat' => 45.404236, 'long' => -74.0379599),
          162 => array(   'city' => 'Verdun', 'lat' => 45.454827, 'long' => -73.569873),
          163 => array(   'city' => 'Victoriaville', 'lat' => 46.0556724, 'long' => -71.9589559),
          164 => array(   'city' => 'Warwick', 'lat' => 41.2638494, 'long' => -74.3822058),
          165 => array(   'city' => 'Westmount', 'lat' => 45.4857189, 'long' => -73.5956993),
          166 => array(   'city' => 'Yamaska', 'lat' => 46.00493601, 'long' => -72.9203846),
        );
      static function setPoints(){
          foreach(self::$cities as $loc){
              \Core\library\Redis::geoadd("canada", $loc['long'], $loc['lat'], $loc['city']);
          }
          log::debug('SETTTTT',"settttttttttttttttttttttttt");
      }
      
      static function getNearestCities($long, $lat){
          log::debug(\Core\library\Redis::exists("canada"), "canada key exists>>>");
          if(\Core\library\Redis::exists("canada") == 0 ){
              self::setPoints();
          }
          $cities = \Core\library\Redis::geoRadius("canada", $long, $lat, self::$radius, self::$unit);
          return array_values($cities);
      }
      
      static function getClosestCities(){
          $geo = \Core\Utils\Session::getGeoLocation();
          if ($geo === Null || !isset($geo->location->longitude)){
              return [];
          }
          return self::getNearestCities($geo->location->longitude, $geo->location->latitude);
      }
      
      static function addCountry(){
          
      }
      static function getLocation($deviceIp){
          
          $geoIpRawData = shell_exec("mmdblookup --file /usr/share/GeoIP/GeoIP2-City.mmdb --ip $deviceIp");
          
          if(NULL === $geoIpRawData) {
            return false;
          }

          $geoIpRawData = preg_replace('/<(.+)>/', ',', $geoIpRawData);
          $geoIpRawData = str_replace(array("\r", "\n", "\t"), '', $geoIpRawData);
          $geoIpRawData = preg_replace("/\s+/", '', $geoIpRawData);
          $geoIpRawData = str_replace(',}', '}', $geoIpRawData);
          $geoIpRawData = str_replace('}{', '},{', $geoIpRawData);
          $geoIpRawData = preg_replace('/}"(\w+)":{/', "},\"$1\":{", $geoIpRawData);
          $geoIpRawData = preg_replace('/}"(\w+)":\[{/', "},\"$1\":[{", $geoIpRawData);
          $geoIpDecodedData = json_decode($geoIpRawData);
         //var_dump($geoIpDecodedData->country);
//          die();
          $country = $geoIpDecodedData->country->iso_code;
          $city    = $geoIpDecodedData->city->names->en;
          $zone    = $geoIpDecodedData->subdivisions[0]->names->en;
         
          return ['country' => $country, "city" => $city, "zone" => $zone, 'countryName' => $geoIpDecodedData->country->names->en];
      }
      
      static function isBlockedIP($ip){
          $geo = self::getLocation($ip); 
          return self::isBlockedCountries($geo['country']);      
      }
      
      static function isBlockedCountries($country){
          return in_array(strtoupper($country),self::$blockedCountries);
      }
      
      static function getCountryID($code){
          return array_search($code,array_keys(self::$countryCodes));
      }
      
  }
?>
